import "core-js/modules/es.symbol";
import "core-js/modules/es.symbol.description";
import "core-js/modules/es.symbol.iterator";
import "core-js/modules/es.array.concat";
import "core-js/modules/es.array.iterator";
import "core-js/modules/es.object.get-prototype-of";
import "core-js/modules/es.object.to-string";
import "core-js/modules/es.string.iterator";
import "core-js/modules/web.dom-collections.for-each";
import "core-js/modules/web.dom-collections.iterator";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

import { AttributeType, gl } from '@antv/l7-core';
import BaseLayer from '../core/BaseLayer';
import { LineTriangulation } from '../core/triangulation';
var line_dash_frag = "uniform float u_blur : 0.9;\nuniform float u_opacity : 1.0;\nuniform float u_dash_offset : 0.0;\nuniform float u_dash_ratio : 0.1;\nvarying vec4 v_color;\nvarying vec2 v_normal;\n\nuniform float u_time;\nuniform vec3 u_aimate: [ 0, 2., 1.0, 0.2 ];\n\nvarying float v_distance_ratio;\nvarying vec2 v_dash_array;\nvoid main() {\n   gl_FragColor = v_color;\n  //  gl_FragColor.a = v_distance_ratio;\n  // anti-alias\n  float blur = 1.- smoothstep(u_blur, 1., length(v_normal.xy)) * u_opacity;\n  // gl_FragColor.a *= blur  * ceil(mod(v_distance_ratio, v_dash_array.x) - v_dash_array.y);\n  gl_FragColor.a *= blur  * (1.0- step(v_dash_array.x, mod(v_distance_ratio, v_dash_array.x +v_dash_array.y)));\n\n\n}\n";
var line_dash_vert = "\nattribute float a_Miter;\nattribute vec4 a_Color;\nattribute float a_Size;\nattribute vec3 a_Normal;\nattribute float a_Total_Distance;\nattribute vec3 a_Position;\nattribute float a_Distance;\nuniform mat4 u_ModelMatrix;\nuniform vec2 u_dash_array: [10.0, 5.];\nuniform  float u_line_type: 0.0;\nuniform float u_dash_offset: 0;\n\nvarying vec4 v_color;\nvarying vec2 v_dash_array;\nvarying vec2 v_normal;\n\nvarying float v_distance_ratio;\n\n\n\n#pragma include \"projection\"\nvoid main() {\n\n   \n  v_distance_ratio = a_Distance / a_Total_Distance;\n\n  v_dash_array = pow(2.0, 20.0 - u_Zoom) * u_dash_array / a_Total_Distance;\n\n  v_normal = vec2(reverse_offset_normal(a_Normal) * sign(a_Miter));\n  v_color = a_Color;\n  vec3 size = a_Miter * a_Size * reverse_offset_normal(a_Normal);  //v_normal * vec3(1., -1., 1.0);\n  vec2 offset = project_pixel(size.xy);\n  vec4 project_pos = project_position(vec4(a_Position.xy, 0, 1.0));\n  gl_Position = project_common_position_to_clipspace(vec4(project_pos.xy + offset, 0, 1.0));\n}\n";

var DashLineLayer = function (_BaseLayer) {
  _inherits(DashLineLayer, _BaseLayer);

  function DashLineLayer() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, DashLineLayer);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(DashLineLayer)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _this.type = 'LineLayer';
    return _this;
  }

  _createClass(DashLineLayer, [{
    key: "getConfigSchema",
    value: function getConfigSchema() {
      return {
        properties: {
          opacity: {
            type: 'number',
            minimum: 0,
            maximum: 1
          }
        }
      };
    }
  }, {
    key: "renderModels",
    value: function renderModels() {
      var _this$getLayerConfig = this.getLayerConfig(),
          opacity = _this$getLayerConfig.opacity,
          _this$getLayerConfig$ = _this$getLayerConfig.dashArray,
          dashArray = _this$getLayerConfig$ === void 0 ? [10, 5] : _this$getLayerConfig$,
          _this$getLayerConfig$2 = _this$getLayerConfig.lineType,
          lineType = _this$getLayerConfig$2 === void 0 ? 'dash' : _this$getLayerConfig$2;

      this.models.forEach(function (model) {
        return model.draw({
          uniforms: {
            u_opacity: opacity || 1.0,
            u_dash_array: dashArray
          }
        });
      });
      return this;
    }
  }, {
    key: "buildModels",
    value: function buildModels() {
      this.registerBuiltinAttributes();
      this.models = [this.buildLayerModel({
        moduleName: 'line_dash',
        vertexShader: line_dash_vert,
        fragmentShader: line_dash_frag,
        triangulation: LineTriangulation,
        blend: {
          enable: true,
          func: {
            srcRGB: gl.SRC_ALPHA,
            srcAlpha: 1,
            dstRGB: gl.ONE_MINUS_SRC_ALPHA,
            dstAlpha: 1
          }
        }
      })];
    }
  }, {
    key: "registerBuiltinAttributes",
    value: function registerBuiltinAttributes() {
      this.styleAttributeService.registerStyleAttribute({
        name: 'size',
        type: AttributeType.Attribute,
        descriptor: {
          name: 'a_Size',
          buffer: {
            usage: gl.DYNAMIC_DRAW,
            data: [],
            type: gl.FLOAT
          },
          size: 1,
          update: function update(feature, featureIdx, vertex, attributeIdx) {
            var size = feature.size;
            return Array.isArray(size) ? [size[0]] : [size];
          }
        }
      });
      this.styleAttributeService.registerStyleAttribute({
        name: 'normal',
        type: AttributeType.Attribute,
        descriptor: {
          name: 'a_Normal',
          buffer: {
            usage: gl.STATIC_DRAW,
            data: [],
            type: gl.FLOAT
          },
          size: 3,
          update: function update(feature, featureIdx, vertex, attributeIdx, normal) {
            return normal;
          }
        }
      });
      this.styleAttributeService.registerStyleAttribute({
        name: 'miter',
        type: AttributeType.Attribute,
        descriptor: {
          name: 'a_Miter',
          buffer: {
            usage: gl.DYNAMIC_DRAW,
            data: [],
            type: gl.FLOAT
          },
          size: 1,
          update: function update(feature, featureIdx, vertex, attributeIdx) {
            return [vertex[4]];
          }
        }
      });
      this.styleAttributeService.registerStyleAttribute({
        name: 'distance',
        type: AttributeType.Attribute,
        descriptor: {
          name: 'a_Distance',
          buffer: {
            usage: gl.DYNAMIC_DRAW,
            data: [],
            type: gl.FLOAT
          },
          size: 1,
          update: function update(feature, featureIdx, vertex, attributeIdx) {
            return [vertex[3]];
          }
        }
      });
      this.styleAttributeService.registerStyleAttribute({
        name: 'total_distance',
        type: AttributeType.Attribute,
        descriptor: {
          name: 'a_Total_Distance',
          buffer: {
            usage: gl.DYNAMIC_DRAW,
            data: [],
            type: gl.FLOAT
          },
          size: 1,
          update: function update(feature, featureIdx, vertex, attributeIdx) {
            return [vertex[5]];
          }
        }
      });
    }
  }]);

  return DashLineLayer;
}(BaseLayer);

export { DashLineLayer as default };
//# sourceMappingURL=dash.js.map