import BaseLayer from '../core/BaseLayer';
import { LineModelType } from './models';
export declare enum LineType {
    'solid' = "solid",
    'dash' = "dash"
}
interface ILineLayerStyleOptions {
    opacity: number;
    lineType?: keyof typeof LineType;
    dashArray?: [number, number];
}
export default class LineLayer extends BaseLayer<ILineLayerStyleOptions> {
    type: string;
    private animateStartTime;
    protected getConfigSchema(): {
        properties: {
            opacity: {
                type: string;
                minimum: number;
                maximum: number;
            };
        };
    };
    protected renderModels(): this;
    protected buildModels(): void;
    protected getModelType(): LineModelType;
    private initAnimate;
}
export {};
