import "core-js/modules/es.array.from";
import "core-js/modules/es.array.iterator";
import "core-js/modules/es.math.log2";
import "core-js/modules/es.object.to-string";
import "core-js/modules/es.string.iterator";
import "core-js/modules/es.typed-array.float32-array";
import "core-js/modules/es.typed-array.copy-within";
import "core-js/modules/es.typed-array.every";
import "core-js/modules/es.typed-array.fill";
import "core-js/modules/es.typed-array.filter";
import "core-js/modules/es.typed-array.find";
import "core-js/modules/es.typed-array.find-index";
import "core-js/modules/es.typed-array.for-each";
import "core-js/modules/es.typed-array.includes";
import "core-js/modules/es.typed-array.index-of";
import "core-js/modules/es.typed-array.iterator";
import "core-js/modules/es.typed-array.join";
import "core-js/modules/es.typed-array.last-index-of";
import "core-js/modules/es.typed-array.map";
import "core-js/modules/es.typed-array.reduce";
import "core-js/modules/es.typed-array.reduce-right";
import "core-js/modules/es.typed-array.reverse";
import "core-js/modules/es.typed-array.set";
import "core-js/modules/es.typed-array.slice";
import "core-js/modules/es.typed-array.some";
import "core-js/modules/es.typed-array.sort";
import "core-js/modules/es.typed-array.subarray";
import "core-js/modules/es.typed-array.to-locale-string";
import "core-js/modules/es.typed-array.to-string";
import Martini from '@mapbox/martini';
export function RasterTriangulation(parserData) {
  var coordinates = parserData.coordinates,
      data = parserData.data,
      min = parserData.min,
      max = parserData.max,
      width = parserData.width,
      height = parserData.height;
  var maxlength = Math.max(width, height);
  var gridSize = Math.pow(2, Math.ceil(Math.log2(maxlength))) + 1;
  var terrain = new Float32Array(gridSize * gridSize);

  for (var i = 0; i < width; i++) {
    for (var j = 0; j < height; j++) {
      terrain[i * gridSize + j] = data[i * width + j];
    }
  }

  var martini = new Martini(gridSize);
  var tile = martini.createTile(terrain);
  var mesh = tile.getMesh(gridSize / 2);
  return {
    vertices: Array.from(mesh.vertices),
    indices: Array.from(mesh.triangles),
    size: 2
  };
}
//# sourceMappingURL=triangulation.js.map