"use strict";

require("core-js/modules/web.dom-collections.for-each");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _l7Utils = require("@antv/l7-utils");

var _inversify = require("inversify");

var _dec, _class;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var LayerStylePlugin = (_dec = (0, _inversify.injectable)(), _dec(_class = function () {
  function LayerStylePlugin() {
    _classCallCheck(this, LayerStylePlugin);
  }

  _createClass(LayerStylePlugin, [{
    key: "apply",
    value: function apply(layer) {
      layer.hooks.afterInit.tap('LayerStylePlugin', function () {
        layer.updateLayerConfig({});

        var _layer$getLayerConfig = layer.getLayerConfig(),
            autoFit = _layer$getLayerConfig.autoFit;

        if (autoFit) {
          layer.fitBounds();
        }
      });
      layer.hooks.beforeRender.tap('LayerStylePlugin', function () {
        var _layer$getLayerConfig2 = layer.getLayerConfig(),
            _layer$getLayerConfig3 = _layer$getLayerConfig2.highlightColor,
            highlightColor = _layer$getLayerConfig3 === void 0 ? 'red' : _layer$getLayerConfig3,
            _layer$getLayerConfig4 = _layer$getLayerConfig2.pickedFeatureID,
            pickedFeatureID = _layer$getLayerConfig4 === void 0 ? -1 : _layer$getLayerConfig4;

        layer.models.forEach(function (model) {
          return model.addUniforms({
            u_PickingStage: 2.0,
            u_PickingColor: (0, _l7Utils.encodePickingColor)(pickedFeatureID),
            u_HighlightColor: (0, _l7Utils.rgb2arr)(highlightColor)
          });
        });
      });
    }
  }]);

  return LayerStylePlugin;
}()) || _class);
exports.default = LayerStylePlugin;
//# sourceMappingURL=LayerStylePlugin.js.map