"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BlendTypes = void 0;

var _l7Core = require("@antv/l7-core");

var _BlendTypes;

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var BlendTypes = (_BlendTypes = {}, _defineProperty(_BlendTypes, _l7Core.BlendType.additive, {
  enable: true,
  func: {
    srcRGB: _l7Core.gl.ONE,
    dstRGB: _l7Core.gl.ONE,
    srcAlpha: 1,
    dstAlpha: 1
  }
}), _defineProperty(_BlendTypes, _l7Core.BlendType.normal, {
  enable: true,
  func: {
    srcRGB: _l7Core.gl.SRC_ALPHA,
    dstRGB: _l7Core.gl.ONE_MINUS_SRC_ALPHA,
    srcAlpha: 1,
    dstAlpha: 1
  }
}), _defineProperty(_BlendTypes, _l7Core.BlendType.subtractive, {
  enable: true,
  func: {
    srcRGB: _l7Core.gl.ONE,
    dstRGB: _l7Core.gl.ONE,
    srcAlpha: _l7Core.gl.ZERO,
    dstAlpha: _l7Core.gl.ONE_MINUS_SRC_COLOR
  },
  equation: {
    rgb: _l7Core.gl.FUNC_SUBTRACT,
    alpha: _l7Core.gl.FUNC_SUBTRACT
  }
}), _defineProperty(_BlendTypes, _l7Core.BlendType.max, {
  enable: true,
  func: {
    srcRGB: _l7Core.gl.ONE,
    dstRGB: _l7Core.gl.ONE
  },
  equation: {
    rgb: _l7Core.gl.MAX_EXT
  }
}), _defineProperty(_BlendTypes, _l7Core.BlendType.min, {
  enable: true,
  func: {
    srcRGB: _l7Core.gl.ONE,
    dstRGB: _l7Core.gl.ONE
  },
  equation: {
    rgb: _l7Core.gl.MIN_EXT
  }
}), _BlendTypes);
exports.BlendTypes = BlendTypes;
//# sourceMappingURL=blend.js.map